﻿Public Module Module1
    Public Function CheckForUpdates( _
        ByVal NewestVersionLocation As String, _
        ByVal NewestVersionDownloadLocation As String, _
        Optional ByVal UnzipDir As String = "", _
        Optional ByVal DisplayWindow As Boolean = True, _
        Optional ByVal MsgBoxText As String = "", _
        Optional ByVal MsgBoxTitle As String = "", _
        Optional ByVal ProcessToKill As String = "", _
        Optional ByVal ProductName As String = "") As Boolean

        On Error GoTo errorhandle 'If there is an error, return false

        Dim dlg As Downloaden = New Downloaden 'Create the download dialog (but don't show it directly)

        If UnzipDir = "" Then 'If the UnzipDir isn't set, use the application's startup path
            dlg.vars_unzipdir = System.Windows.Forms.Application.StartupPath 'wfh FIX maybe and pass in path of process to kill?
        End If

        If MsgBoxText <> "" Then 'If the MsgBoxText isn't set, use the default text
            dlg.vars_bericht = MsgBoxText
        End If

        If MsgBoxTitle <> "" Then  'If the MsgBoxTitle isn't set, use the default title
            dlg.vars_berichttitel = MsgBoxTitle
        End If

        'wfh added
        If ProcessToKill <> "" Then  'If the original calling process is available for killing
            dlg.vars_ProcessToKill = ProcessToKill
        End If

        'wfh added
        If ProductName <> "" Then  'If the ProductName is passed in
            dlg.vars_ProductName = ProductName
        End If
        dlg.vars_downloadlocatie = NewestVersionDownloadLocation 'Set the NewestVersionDownloadLocation var in the dialog
        dlg.vars_versielocatie = NewestVersionLocation 'Set the NewestVersionLocation var in the dialog

        If DisplayWindow <> False Then 'If the DisplayWindow var is set, display the dialog, otherwise not.
            dlg.ShowDialog()
        End If
        Dim style As MsgBoxStyle = MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton1
        If dlg.NieuweVersieBeschikbaar(dlg.vars_versielocatie) Then 'Check if there is a newer version available
            If MsgBox(dlg.vars_bericht, style, dlg.vars_berichttitel) = MsgBoxResult.Yes Then 'Display MsgBox to ask to download newest version
                'wfh added
                If dlg.vars_ProcessToKill <> "" Then
                    dlg.KillProcess(dlg.vars_ProcessToKill)
                End If
                ' wfh FIX should do some error checking here!!!
                dlg.CheckForUpdates(dlg.vars_downloadlocatie) 'Download the file, if wanted
                If MsgBox("Updated to version " & dlg.vars_Version & "." & ControlChars.CrLf _
                & "Do you want to restart " & dlg.vars_ProductName & "?", style, "wordFrequency Updated") = MsgBoxResult.Yes Then
                    Process.Start(dlg.vars_ProductName & ".exe")
                End If
            Else
                dlg.Close() 'Otherwise, close the download window
            End If
        Else
            MsgBox("You have version  " & dlg.vars_Version & " which is the latest version of " & dlg.vars_ProductName & ".", MsgBoxStyle.Information, "wordFrequency Up to Date")
            dlg.Close() 'Close the download window if there isn't a newer version available
        End If
        Return True 'Return true if all's gone well
        Exit Function
errorhandle:
        Return False
    End Function
End Module
